Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 505)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 509)
@@ -1792,7 +1792,7 @@
 		<element name="i" type="string"/>
 		<element name="Vstyle" type="string" max="-1" default="joint"/>
-		<element name="vr" type="float" min="0" max="1" default="0.5"/>
-		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
-		<element name="vb" type="float" min="0" max="1" default="0.5" flags="1024"/>
+		<element name="vr" type="float" min="0" max="1" default="1.0"/>
+		<element name="vg" type="float" min="0" max="1" default="1.0" flags="1024"/>
+		<element name="vb" type="float" min="0" max="1" default="1.0" flags="1024"/>
 	</type>
 	<type name="Loader" context="Global context">
@@ -2829,7 +2829,7 @@
 		<element name="Vstyle" type="string" max="-1" default="part"/>
 		<element name="vs" type="float" min="0.05" max="0.7" default="0.2"/>
-		<element name="vr" type="float" min="0" max="1" default="0.5"/>
-		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
-		<element name="vb" type="float" min="0" max="1" default="0.5" flags="1024"/>
+		<element name="vr" type="float" min="0" max="1" default="1.0"/>
+		<element name="vg" type="float" min="0" max="1" default="1.0" flags="1024"/>
+		<element name="vb" type="float" min="0" max="1" default="1.0" flags="1024"/>
 	</type>
 	<type name="Population" context="Global context">
@@ -3103,4 +3103,28 @@
 		</element>
 		<element name="iterator" type="Object" flags="291"/>
+	</type>
+	<type name="POVExport" context="Global context">
+		<element name="povex_outdir" type="string" default=".">
+			<description><![CDATA[Directory name WITHOUT trailing '/' sign]]></description>
+		</element>
+		<element name="povex_outfiles" type="string" default="scene_%04d.pov">
+			<description><![CDATA[Frame number replaces %d (eg. 'scene%03d.pov')]]></description>
+		</element>
+		<element name="povex_skip" type="integer" min="0" max="100" default="0">
+			<description><![CDATA[A scene file is generated each (n+1) simulation steps
+(a small value means more frames and smooth animation)]]></description>
+		</element>
+		<element name="povex_startf" type="integer" min="0" max="1000000" default="0">
+			<description><![CDATA[Starting number]]></description>
+		</element>
+		<element name="povex_maxframes" type="integer" min="0" max="1000000" default="10000">
+			<description><![CDATA[How many frames are to be generated?]]></description>
+		</element>
+		<element name="povex_enable" function="true" flags="8"/>
+		<element name="povex_disable" function="true" flags="8"/>
+		<element name="povex_now" function="true" flags="8"/>
+		<element name="povex_currframe" type="integer" flags="18"/>
+		<element name="povex_enabled" type="integer" min="0" max="1" flags="18"/>
+		<element name="povex_lastfile" type="string" flags="18"/>
 	</type>
 	<type name="Ref" context="Global context">
@@ -5908,7 +5932,7 @@
 		<element name="i" type="string"/>
 		<element name="Vstyle" type="string" max="-1" default="joint"/>
-		<element name="vr" type="float" min="0" max="1" default="0.5"/>
-		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
-		<element name="vb" type="float" min="0" max="1" default="0.5" flags="1024"/>
+		<element name="vr" type="float" min="0" max="1" default="1.0"/>
+		<element name="vg" type="float" min="0" max="1" default="1.0" flags="1024"/>
+		<element name="vb" type="float" min="0" max="1" default="1.0" flags="1024"/>
 	</type>
 	<type name="Loader" context="Visual style definition">
@@ -6017,7 +6041,7 @@
 		<element name="Vstyle" type="string" max="-1" default="part"/>
 		<element name="vs" type="float" min="0.05" max="0.7" default="0.2"/>
-		<element name="vr" type="float" min="0" max="1" default="0.5"/>
-		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
-		<element name="vb" type="float" min="0" max="1" default="0.5" flags="1024"/>
+		<element name="vr" type="float" min="0" max="1" default="1.0"/>
+		<element name="vg" type="float" min="0" max="1" default="1.0" flags="1024"/>
+		<element name="vb" type="float" min="0" max="1" default="1.0" flags="1024"/>
 	</type>
 	<type name="Scene" context="Visual style definition">