Index: /cpp/frams/_demos/f0_variants_test.cpp
===================================================================
--- /cpp/frams/_demos/f0_variants_test.cpp	(revision 533)
+++ /cpp/frams/_demos/f0_variants_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -94,5 +94,5 @@
 	}
 Geno g(gen);
-printf("\nSource genotype: '%s'\n",g.getGene().c_str());
+printf("\nSource genotype: '%s'\n",g.getGenes().c_str());
 printf("                  ( format %c %s)\n",
        g.getFormat(), g.getComment().c_str());
Index: /cpp/frams/_demos/full_props.cpp
===================================================================
--- /cpp/frams/_demos/full_props.cpp	(revision 533)
+++ /cpp/frams/_demos/full_props.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -97,5 +97,5 @@
 Geno f0_g;
 m.makeGeno(f0_g,NULL,reverse);//third arg is "handle_defaults" == whether f0 should omit default property values
-puts(f0_g.getGeneAndFormat().c_str());
+puts(f0_g.getGenesAndFormat().c_str());
 
 return 0;
Index: /cpp/frams/_demos/genoconv_test.cpp
===================================================================
--- /cpp/frams/_demos/genoconv_test.cpp	(revision 533)
+++ /cpp/frams/_demos/genoconv_test.cpp	(revision 534)
@@ -51,5 +51,5 @@
 mod.getPart(1)->p=Pt3D(0,0.2,-1);
 mod.close();
-return mod.getGeno().getGene();
+return mod.getGeno().getGenes();
 }
 ~GenoConv_Test2() {}
@@ -112,5 +112,5 @@
 {
 printf("Genotype:\n%s\nFormat: %c\nValid: %s\nComment: %s\n",
-	g.getGene().c_str(),g.getFormat(),g.isValid()?"yes":"no",g.getComment().c_str());
+	g.getGenes().c_str(),g.getFormat(),g.isValid()?"yes":"no",g.getComment().c_str());
 }
 
@@ -159,19 +159,19 @@
 	printf("conversion map:\n");
 	m.print();
-	printConvMap(g1.getGene(),g2.getGene(),m);
+	printConvMap(g1.getGenes(),g2.getGenes(),m);
 	printf("reverse conversion map:\n");
 	MultiMap rm;
 	rm.addReversed(m);
 	rm.print();
-	printConvMap(g2.getGene(),g1.getGene(),rm);
+	printConvMap(g2.getGenes(),g1.getGenes(),rm);
 	}
 
 Model mod1(g1,1);
 printf("\nmodel map for f%c genotype:\n",g1.getFormat());
-printModelMap(g1.getGene(),mod1.getMap());
+printModelMap(g1.getGenes(),mod1.getMap());
 mod1.getMap().print();
 Model mod2(g2,1);
 printf("\nmodel map for f%c genotype:\n",g2.getFormat());
-printModelMap(g2.getGene(),mod2.getMap());
+printModelMap(g2.getGenes(),mod2.getMap());
 mod2.getMap().print();
 return 0;
Index: /cpp/frams/_demos/genomanipulation.cpp
===================================================================
--- /cpp/frams/_demos/genomanipulation.cpp	(revision 533)
+++ /cpp/frams/_demos/genomanipulation.cpp	(revision 534)
@@ -79,5 +79,5 @@
 CHANGE_ONE_PROPERTY(p->extraProperties());
 p->getModel().close();
-printf("\nLet's see f0... (check out part #%d !)\n\n%s\n", p->refno, p->getModel().getF0Geno().getGene().c_str());
+printf("\nLet's see f0... (check out part #%d !)\n\n%s\n", p->refno, p->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -91,5 +91,5 @@
 j->getModel().close();
 printf("The Part's position is changed, but everything else stays intact:\n\n%s\n",
-       j->getModel().getF0Geno().getGene().c_str());
+       j->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -104,5 +104,5 @@
 j->getModel().close();
 printf("Position of the second Part referenced by this joint (part #%d) is now changed:\n\n%s\n",
-       j->part2->refno, j->getModel().getF0Geno().getGene().c_str());
+       j->part2->refno, j->getModel().getF0Geno().getGenes().c_str());
 printf("If no delta fields are defined, they will be computed automatically.\n"
        "You can always delete existing delta values by using Joint::resetDelta().\n"
@@ -112,5 +112,5 @@
 j->resetDelta();
 j->getModel().close();
-printf("As you can see, Joint's delta fields have altered:\n\n%s\n", j->getModel().getF0Geno().getGene().c_str());
+printf("As you can see, Joint's delta fields have altered:\n\n%s\n", j->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -123,5 +123,5 @@
 j->getModel().close();
 printf("f0 is now:\n\n%s\n...so this is %s joint.\n",
-       j->getModel().getF0Geno().getGene().c_str(), option?"a delta":"an absolute");
+       j->getModel().getF0Geno().getGenes().c_str(), option?"a delta":"an absolute");
 
 }
@@ -155,5 +155,5 @@
 CHANGE_ONE_PROPERTY(j->extraProperties());
 j->getModel().close();
-printf("And after that we have this genotype:\n\n%s\n", j->getModel().getF0Geno().getGene().c_str());
+printf("And after that we have this genotype:\n\n%s\n", j->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -250,5 +250,5 @@
 n->getModel().close();
 printf("The final object description will be then: '%s'\nAnd the full f0 genotype:\n\n%s\n",
-       n->getDetails().c_str(), n->getModel().getF0Geno().getGene().c_str());
+       n->getDetails().c_str(), n->getModel().getF0Geno().getGenes().c_str());
 
 
@@ -281,5 +281,5 @@
 	}
 Geno g(gen);
-printf("\nSource genotype: '%s'\n",g.getGene().c_str());
+printf("\nSource genotype: '%s'\n",g.getGenes().c_str());
 printf("                  ( format %c %s)\n",
        g.getFormat(), g.getComment().c_str());
@@ -292,5 +292,5 @@
 	return 2;	
 	}
-printf("Converted to f0:\n%s\n",m.getF0Geno().getGene().c_str());
+printf("Converted to f0:\n%s\n",m.getF0Geno().getGenes().c_str());
 
 printf("Model contains: %d part(s)\n"
Index: /cpp/frams/_demos/genooper_test.cpp
===================================================================
--- /cpp/frams/_demos/genooper_test.cpp	(revision 533)
+++ /cpp/frams/_demos/genooper_test.cpp	(revision 534)
@@ -9,5 +9,5 @@
 {
 	printf("Genotype: %s\nFormat: %c\nValid: %s\nComment: %s\n",
-		g.getGene().c_str(), g.getFormat(), g.isValid() ? "yes" : "no", g.getComment().len() == 0 ? "(empty)" : g.getComment().c_str());
+		g.getGenes().c_str(), g.getFormat(), g.isValid() ? "yes" : "no", g.getComment().len() == 0 ? "(empty)" : g.getComment().c_str());
 }
 
@@ -47,5 +47,5 @@
 	printGenAndTitle(gvalidated, "validated");
 
-	printf("\nHTMLized: %s\n", genetics.genman.HTMLize(gvalidated.getGene().c_str()).c_str());
+	printf("\nHTMLized: %s\n", genetics.genman.HTMLize(gvalidated.getGenes().c_str()).c_str());
 
 	return 0;
Index: /cpp/frams/_demos/geometry/apices_test.cpp
===================================================================
--- /cpp/frams/_demos/geometry/apices_test.cpp	(revision 533)
+++ /cpp/frams/_demos/geometry/apices_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -47,5 +47,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 }
 
Index: /cpp/frams/_demos/geometry/info_test.cpp
===================================================================
--- /cpp/frams/_demos/geometry/info_test.cpp	(revision 533)
+++ /cpp/frams/_demos/geometry/info_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -72,5 +72,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 	
 	// Printing calculated values.
Index: /cpp/frams/_demos/geometry/surface_test.cpp
===================================================================
--- /cpp/frams/_demos/geometry/surface_test.cpp	(revision 533)
+++ /cpp/frams/_demos/geometry/surface_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -47,5 +47,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 }
 
Index: /cpp/frams/_demos/geometry/volume_test.cpp
===================================================================
--- /cpp/frams/_demos/geometry/volume_test.cpp	(revision 533)
+++ /cpp/frams/_demos/geometry/volume_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -39,5 +39,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 }
 
Index: /cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- /cpp/frams/_demos/multiline_f0_test.cpp	(revision 533)
+++ /cpp/frams/_demos/multiline_f0_test.cpp	(revision 534)
@@ -26,5 +26,5 @@
 	}
 Geno g(gen);
-printf("\nSource genotype: '%s'\n",g.getGene().c_str());
+printf("\nSource genotype: '%s'\n",g.getGenes().c_str());
 printf("                  ( format %c %s)\n",
        g.getFormat(), g.getComment().c_str());
@@ -37,5 +37,5 @@
 	return 2;	
 	}
-printf("Converted to f0:\n%s\n",m.getF0Geno().getGene().c_str());
+printf("Converted to f0:\n%s\n",m.getF0Geno().getGenes().c_str());
 
 printf("\nusing Param::save() to create the \"expanded\" form of the f0 genotype...\n(MultiParamLoader should be able to load this)");
Index: /cpp/frams/_demos/part_shapes.cpp
===================================================================
--- /cpp/frams/_demos/part_shapes.cpp	(revision 533)
+++ /cpp/frams/_demos/part_shapes.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -52,5 +52,5 @@
 
 	m.close();
-	puts(m.getF0Geno().getGeneAndFormat().c_str());
+	puts(m.getF0Geno().getGenesAndFormat().c_str());
 	// the genotype can be fed directly to the genotype viewer, like this:
 	// part_shapes | theater -g -
Index: /cpp/frams/_demos/shapeconvert.cpp
===================================================================
--- /cpp/frams/_demos/shapeconvert.cpp	(revision 533)
+++ /cpp/frams/_demos/shapeconvert.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -87,5 +87,5 @@
 
 	Geno f0_g = newmodel.getF0Geno();
-	puts(f0_g.getGeneAndFormat().c_str());
+	puts(f0_g.getGenesAndFormat().c_str());
 
 	return 0;
Index: /cpp/frams/genetics/f1/conv_f1.cpp
===================================================================
--- /cpp/frams/genetics/f1/conv_f1.cpp	(revision 533)
+++ /cpp/frams/genetics/f1/conv_f1.cpp	(revision 534)
@@ -111,5 +111,5 @@
 builder.model.close(); // model is ready to use now
 if (map) builder.model.getCurrentToF0Map(*map); // generate f1-to-f0 conversion map
-return builder.model.getF0Geno().getGene();
+return builder.model.getF0Geno().getGenes();
 }
 
Index: /cpp/frams/genetics/f4/conv_f4.cpp
===================================================================
--- /cpp/frams/genetics/f4/conv_f4.cpp	(revision 533)
+++ /cpp/frams/genetics/f4/conv_f4.cpp	(revision 534)
@@ -32,5 +32,5 @@
 		// generate to-f0 conversion map
 		model->getCurrentToF0Map(*map);
-	SString out = model->getF0Geno().getGene();
+	SString out = model->getF0Geno().getGenes();
 	delete model;
 	return out;
Index: /cpp/frams/genetics/f9/conv_f9.cpp
===================================================================
--- /cpp/frams/genetics/f9/conv_f9.cpp	(revision 533)
+++ /cpp/frams/genetics/f9/conv_f9.cpp	(revision 534)
@@ -56,5 +56,5 @@
 	if (map != NULL)
 		m.getCurrentToF0Map(*map);
-	return m.getF0Geno().getGene();
+	return m.getF0Geno().getGenes();
 }
 
Index: /cpp/frams/genetics/genman.cpp
===================================================================
--- /cpp/frams/genetics/genman.cpp	(revision 533)
+++ /cpp/frams/genetics/genman.cpp	(revision 534)
@@ -198,5 +198,5 @@
 int GenMan::testValidity(Geno &g, bool &canvalidate)
 {
-	SString ggs=g.getGene();
+	SString ggs=g.getGenes();
 	const char *gg = ggs.c_str();
 	GenoOperators *gf = getOper_f(g.getFormat());
@@ -210,8 +210,8 @@
 	if (check1 == GENOPER_NOOPER) //disaster: cannot check because there is no check operator
 	{
-		g.setGeneOnly(g2); free(g2); canvalidate = false; return GENOPER_NOOPER;
+		g.setGenesAssumingSameFormat(g2); free(g2); canvalidate = false; return GENOPER_NOOPER;
 	}
 	int check2 = gf->checkValidity(g2, "validated");
-	if (check2 == GENOPER_OK) g.setGeneOnly(g2);
+	if (check2 == GENOPER_OK) g.setGenesAssumingSameFormat(g2);
 	free(g2);
 	if (check2 == GENOPER_OK) return check1;
@@ -237,5 +237,5 @@
 	if (gf == NULL)
 		return Geno(SString::empty(), -1, SString::empty(), SString::sprintf("GENOPER_NOOPER: Validate(): don't know how to handle genetic format %c", format));
-	char *g2 = strdup(geny.getGene().c_str()); //copy for validation
+	char *g2 = strdup(geny.getGenes().c_str()); //copy for validation
 	int res = gf->validate(g2, geny.getName().c_str());
 	SString sg2 = g2;
@@ -263,5 +263,5 @@
 	while (!ok)
 	{
-		char *gn = strdup(gv.getGene().c_str()); //copy for mutation
+		char *gn = strdup(gv.getGenes().c_str()); //copy for mutation
 		chg = 0;
 		if (gf->mutate(gn, chg, method) == GENOPER_OK)
@@ -284,10 +284,10 @@
 		if (!ok && (count - pcount > 100))
 		{
-			logPrintf("GenMan", "Mutate", 2, "Tried 100x and failed: %s", g.getGene().c_str());
+			logPrintf("GenMan", "Mutate", 2, "Tried 100x and failed: %s", g.getGenes().c_str());
 			return Geno("", -1, "", "GENOPER_OPFAIL: Mutate() tried 100x and failed");
 		}
 	}
 	mutchg += chg;
-	if (history) saveLink(g.getGene().c_str(), "", gv.getGene().c_str(), chg);
+	if (history) saveLink(g.getGenes().c_str(), "", gv.getGenes().c_str(), chg);
 	SString mutinfo;
 	if (extmutinfo == 0) mutinfo = SString::sprintf("%.2f%% mutation of '%s'", 100 * chg, g.getName().c_str()); else
@@ -324,6 +324,6 @@
 	{
 		float chg1, chg2;
-		char *g1n = strdup(g1.getGene().c_str()); //copy for crossover
-		char *g2n = strdup(g2.getGene().c_str()); //copy for crossover
+		char *g1n = strdup(g1.getGenes().c_str()); //copy for crossover
+		char *g2n = strdup(g2.getGenes().c_str()); //copy for crossover
 		chg1 = chg2 = 0;
 		if (gf->crossOver(g1n, g2n, chg1, chg2) == GENOPER_OK)
@@ -351,5 +351,5 @@
 		if (!ok && (count - pcount > 100))
 		{
-			logPrintf("GenMan", "CrossOver", 2, "Tried 100x and failed: %s and %s", g1.getGene().c_str(), g2.getGene().c_str());
+			logPrintf("GenMan", "CrossOver", 2, "Tried 100x and failed: %s and %s", g1.getGenes().c_str(), g2.getGenes().c_str());
 			return Geno("", -1, "", "GENOPER_OPFAIL: CrossOver() tried 100x and failed");
 		}
@@ -357,5 +357,5 @@
 	// result in g1v
 	xochg += chg;
-	if (history) saveLink(g1.getGene().c_str(), g2.getGene().c_str(), g1v.getGene().c_str(), chg);
+	if (history) saveLink(g1.getGenes().c_str(), g2.getGenes().c_str(), g1v.getGenes().c_str(), chg);
 	SString xoinfo = SString::sprintf("Crossing over of '%s' (%.2f%%) and '%s' (%.2f%%)",
 		g1.getName().c_str(), 100 * chg, g2.getName().c_str(), 100 * (1 - chg));
@@ -369,5 +369,5 @@
 	if (format != g2.getFormat()) return GENOPER_NOOPER;
 	GenoOperators *gf = getOper_f(format);
-	if (!gf) return GENOPER_NOOPER; else return gf->similarity(g1.getGene().c_str(), g2.getGene().c_str());
+	if (!gf) return GENOPER_NOOPER; else return gf->similarity(g1.getGenes().c_str(), g2.getGenes().c_str());
 }
 
@@ -380,5 +380,5 @@
 	GenoOperators *gf = getOper_f(format);
 	if (!gf) return GENSTYLE_CS(0, 0); //black & valid
-	else return gf->style(G->getGene().c_str(), pos);
+	else return gf->style(G->getGenes().c_str(), pos);
 }
 
@@ -399,5 +399,5 @@
 	}
 	GenoOperators *gf = getOper_f(format);
-	SString geny=G->getGene();
+	SString geny=G->getGenes();
 	for (unsigned int pos = 0; pos < strlen(g); pos++)
 	{
Index: /cpp/frams/genetics/geno.cpp
===================================================================
--- /cpp/frams/genetics/geno.cpp	(revision 533)
+++ /cpp/frams/genetics/geno.cpp	(revision 534)
@@ -32,8 +32,8 @@
 	name = genname;
 	txt = comment;
-	setGeneAndFormat(genstring,genformat);
-}
-
-void Geno::setGeneAndFormat(const SString& genstring, char genformat)
+	setGenesAndFormat(genstring,genformat);
+}
+
+void Geno::setGenesAndFormat(const SString& genstring, char genformat)
 {
 	mapinshift = 0;
@@ -151,5 +151,5 @@
 }
 
-void Geno::setGeneOnly(const SString& g)
+void Geno::setGenesAssumingSameFormat(const SString& g)
 {
 	gen = g;
@@ -174,5 +174,5 @@
 }
 
-SString Geno::getGeneAndFormat(void) const
+SString Geno::getGenesAndFormat(void) const
 {
 	SString out;
@@ -211,5 +211,5 @@
 }
 
-SString Geno::getGene(void) const { return gen; }
+SString Geno::getGenes(void) const { return gen; }
 SString Geno::getName(void) const { return name; }
 char Geno::getFormat(void) const { return format; }
Index: /cpp/frams/genetics/geno.h
===================================================================
--- /cpp/frams/genetics/geno.h	(revision 533)
+++ /cpp/frams/genetics/geno.h	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -85,13 +85,13 @@
 
 	/// return string representation, with format comment at the beginning
-	SString getGeneAndFormat(void) const;
+	SString getGenesAndFormat(void) const;
 
 	void setString(const SString& genewithcomments);
 
-	/** @param genformat=-1 -> take from genstring comment (like the constructor) else specify the valid format in genformat and pure gene in genstring */
-	void setGeneAndFormat(const SString& genstring, char genformat=-1);
-	/** g must be pure gene, without format. for the standard behavior use setGeneAndFormat() */
-	void setGeneOnly(const SString& g);
-	SString getGene(void) const;
+	/** @param genformat=-1 -> detect genotype format from genstring comment (like the constructor does), else specify the valid format in genformat and pure genes in genstring. */
+	void setGenesAndFormat(const SString& genstring, char genformat=-1);
+	/** g must be pure genes, without format. For the standard behavior use setGenesAndFormat() */
+	void setGenesAssumingSameFormat(const SString& g);
+	SString getGenes(void) const;
 
 	SString getName(void) const;
Index: /cpp/frams/genetics/genoconv.cpp
===================================================================
--- /cpp/frams/genetics/genoconv.cpp	(revision 533)
+++ /cpp/frams/genetics/genoconv.cpp	(revision 534)
@@ -181,5 +181,5 @@
 	char *t = path;
 	SString tmp;
-	tmp = in.getGene();
+	tmp = in.getGenes();
 	MultiMap lastmap, tmpmap;
 	int firstmap = 1;
Index: /cpp/frams/model/autoname.cpp
===================================================================
--- /cpp/frams/model/autoname.cpp	(revision 533)
+++ /cpp/frams/model/autoname.cpp	(revision 534)
@@ -54,5 +54,5 @@
 SString AutoName::firstName(Model& model)
 {
-	return firstName(model.getGeno().getGene());
+	return firstName(model.getGeno().getGenes());
 }
 
Index: /cpp/frams/model/model.cpp
===================================================================
--- /cpp/frams/model/model.cpp	(revision 533)
+++ /cpp/frams/model/model.cpp	(revision 534)
@@ -308,5 +308,5 @@
 		return;
 	}
-	SString f0txt = f0geno.getGene();
+	SString f0txt = f0geno.getGenes();
 	buildstatus = building; // was: open();
 	if (autobuildmaps)
Index: /cpp/frams/vm/classes/genoobj.cpp
===================================================================
--- /cpp/frams/vm/classes/genoobj.cpp	(revision 533)
+++ /cpp/frams/vm/classes/genoobj.cpp	(revision 534)
@@ -53,5 +53,5 @@
 void GenoObj::get_genotype(ExtValue *ret)
 {
-	ret->setString(getGene());
+	ret->setString(getGenes());
 }
 
@@ -80,5 +80,5 @@
 void GenoObj::get_string(ExtValue *ret)
 {
-	ret->setString(getGeneAndFormat());
+	ret->setString(getGenesAndFormat());
 }
 
@@ -97,5 +97,5 @@
 void GenoObj::get_f0genotype(ExtValue *ret)
 {
-	ret->setString(getConverted('0').getGene());
+	ret->setString(getConverted('0').getGenes());
 }
 
@@ -178,5 +178,5 @@
 {
 	VectorObject *vec = new VectorObject;
-	vec->data += new ExtValue(getGeneAndFormat());
+	vec->data += new ExtValue(getGenesAndFormat());
 	vec->data += new ExtValue(getName());
 	vec->data += new ExtValue(getComment());