Index: cpp/frams/model/model.cpp
===================================================================
--- cpp/frams/model/model.cpp	(revision 541)
+++ cpp/frams/model/model.cpp	(revision 544)
@@ -944,11 +944,11 @@
 			if (p->p.z + p->size > bbmax.z) bbmax.z = p->p.z + p->size;
 			if (shape == SHAPE_UNKNOWN)
-				shape = (p->shape == Part::SHAPE_DEFAULT) ? SHAPE_OLD : SHAPE_NEW;
+				shape = (p->shape == Part::SHAPE_BALL_AND_STICK) ? SHAPE_BALL_AND_STICK : SHAPE_SOLIDS;
 			else if (shape != SHAPE_ILLEGAL)
 			{
-				if ((p->shape == Part::SHAPE_DEFAULT) ^ (shape == SHAPE_OLD))
+				if ((p->shape == Part::SHAPE_BALL_AND_STICK) ^ (shape == SHAPE_BALL_AND_STICK))
 				{
 					shape = SHAPE_ILLEGAL;
-					logPrintf("Model", "internalCheck", LOG_WARN, "Inconsistent part shapes (mixed old and new shapes)%s", nameForErrors().c_str());
+					logPrintf("Model", "internalCheck", LOG_WARN, "Inconsistent part shapes (mixed ball-and-stick and solids shape types)%s", nameForErrors().c_str());
 				}
 			}
@@ -1014,5 +1014,5 @@
 				if (final)
 				{
-					if (j->shape != Joint::SHAPE_SOLID)
+					if (j->shape != Joint::SHAPE_FIXED)
 					{
 						if (j->d() > getMaxJoint().d.x)
@@ -1031,5 +1031,5 @@
 			if (shape != SHAPE_ILLEGAL)
 			{
-				if ((j->shape == Joint::SHAPE_DEFAULT) ^ (shape == SHAPE_OLD))
+				if ((j->shape == Joint::SHAPE_BALL_AND_STICK) ^ (shape == SHAPE_BALL_AND_STICK))
 				{
 					shape = SHAPE_ILLEGAL;
@@ -1363,5 +1363,5 @@
 					if ((oj2->part1 == op) || (oj2->part2 == op))
 					{
-						addNewJoint(getPart(j), getPart(j2), Joint::SHAPE_SOLID);
+						addNewJoint(getPart(j), getPart(j2), Joint::SHAPE_FIXED);
 					}
 				}
Index: cpp/frams/model/model.h
===================================================================
--- cpp/frams/model/model.h	(revision 541)
+++ cpp/frams/model/model.h	(revision 544)
@@ -119,7 +119,7 @@
 
 public:
-	enum Shape { SHAPE_UNKNOWN, SHAPE_ILLEGAL, SHAPE_OLD, SHAPE_NEW };
+	enum ShapeType { SHAPE_UNKNOWN, SHAPE_ILLEGAL, SHAPE_BALL_AND_STICK, SHAPE_SOLIDS };
 protected:
-	Shape shape;
+	ShapeType shape;
 
 	void updateNeuroRefno(); // set Neuro::refno for all neurons
@@ -156,5 +156,5 @@
 	int isValid() const { return buildstatus == valid; }
 	int getErrorPosition(bool includingwarnings = false);
-	Shape getShape() { return shape; }
+	ShapeType getShapeType() const { return shape; }
 
 	void updateRefno(); // set ::refno for all elements
@@ -359,7 +359,7 @@
 
 	/** create new Part and add it to the model. @see addPart()  */
-	Part *addNewPart(Part::Shape shape = Part::SHAPE_DEFAULT) { return addPart(new Part(shape)); }
+	Part *addNewPart(Part::Shape shape = Part::SHAPE_BALL_AND_STICK) { return addPart(new Part(shape)); }
 	/** create new Joint and add it to the model. @see addJoint() */
-	Joint *addNewJoint(Part *p1 = NULL, Part *p2 = NULL, Joint::Shape shape = Joint::SHAPE_DEFAULT) { Joint *j = addJoint(new Joint()); j->shape = shape; if ((p1 != NULL) && (p2 != NULL)) j->attachToParts(p1, p2); return j; }
+	Joint *addNewJoint(Part *p1 = NULL, Part *p2 = NULL, Joint::Shape shape = Joint::SHAPE_BALL_AND_STICK) { Joint *j = addJoint(new Joint()); j->shape = shape; if ((p1 != NULL) && (p2 != NULL)) j->attachToParts(p1, p2); return j; }
 	/** create new Neuro and add it to the model. @see addNeuro() */
 	Neuro *addNewNeuro() { return addNeuro(new Neuro()); }
Index: cpp/frams/model/modelparts.h
===================================================================
--- cpp/frams/model/modelparts.h	(revision 541)
+++ cpp/frams/model/modelparts.h	(revision 544)
@@ -85,5 +85,5 @@
 ///
 paInt shape;///default=old Framsticks compatible, do not mix with shapes>0
-enum Shape {SHAPE_DEFAULT=0, SHAPE_ELLIPSOID=1, SHAPE_CUBOID=2, SHAPE_CYLINDER=3};
+enum Shape {SHAPE_BALL_AND_STICK=0, SHAPE_ELLIPSOID=1, SHAPE_CUBOID=2, SHAPE_CYLINDER=3};
 double mass,size,density,friction,ingest,assim,hollow;
 Pt3D scale;
@@ -95,5 +95,5 @@
 double vsize;
 
-Part(enum Shape s=SHAPE_DEFAULT);
+Part(enum Shape s=SHAPE_BALL_AND_STICK);
 Part(const Part& src):PartBase(getDefaultStyle()) {operator=(src);}
 void operator=(const Part& src);
@@ -124,6 +124,6 @@
 class Pt3D d;		///< position delta between parts
 class Pt3D rot;	///< orientation delta between parts expressed as 3 angles
-enum Shape {SHAPE_DEFAULT=0, SHAPE_SOLID=1};
-paInt shape;///< default=old Framsticks compatible, creates a physical rod between parts (cylinder or cuboid), do not mix with shape>0,  solid=merge parts into one physical entity
+enum Shape {SHAPE_BALL_AND_STICK=0, SHAPE_FIXED=1};
+paInt shape;///< ball-and-stick=old Framsticks compatible, creates a physical rod between parts (cylinder or cuboid), do not mix with shape>0,  fixed=merge parts into one physical entity
 
 Joint();